/*
gulpfile.js
===========
Rather than manage one giant configuration file responsible
for creating multiple tasks, each task has been broken out into
its own file in gulpfile.js/tasks. Any files in that directory get
automatically required below.

To add a new task, simply add a new task file into that directory.
gulpfile.js/tasks/default.js specifies the default set of tasks to run
when you run `gulp`.
*/

var requireDir = require('require-dir')
var config     = require('./lib/configReader.js')
var path       = require('path')

// Require all tasks in gulpfile.js/tasks, including subfolders
requireDir('./tasks', { recurse: true })
if ((config.customDevTasks && config.customDevTasks.length > 0) || (config.customProdTasks && config.customProdTasks.length > 0)) {
    requireDir(path.join(config.root.src, 'tasks'), {recurse: true});
}
