var config  = require('./configReader.js')
var compact = require('lodash/compact')

// Grouped by what can run in parallel
var assetTasks = ['fonts', 'iconFont', 'images', 'svgSprite', 'videos']
var codeTasks = ['html', 'css', 'js']

module.exports = function(env) {
  function matchFilter(task) {
    if(config.tasks[task]) {
      if(task === 'js') {
        if(env == 'production') {
          task = 'webpack:production';
        } else if (env === 'debug') {
          task = 'webpack:debug';
        } else {
          task = false;
        }
      }
      return task
    }
  }

  function exists(value) {
    return !!value
  }

  return {
    assetTasks: compact(assetTasks.map(matchFilter).filter(exists)),
    codeTasks: compact(codeTasks.map(matchFilter).filter(exists)),
    customDevTasks: (env === 'watch' || env === 'development' || env === 'debug') ? config.customDevTasks : [],
    customProdTasks: (env === 'production') ? config.customProdTasks : []
  }
}
