if(global.production) return

var browserSync 		= require('browser-sync')
var config      		= require('../lib/configReader.js')
var gulp        		= require('gulp')
var webpack           	= require('webpack')
var webpackMutiConfig 	= require('../lib/webpack-multi-config')
var merge       		= require('merge');
var path   				= require('path')
var pathToUrl           = require('../lib/pathToUrl')
var historyApiFallback  = require('connect-history-api-fallback')

var browserSyncTask = function() {
  var browserSyncConfig = merge(true, config.tasks.browserSync, {});
  browserSyncConfig.server.baseDir = browserSyncConfig.server.baseDir.map(function(b) { return path.resolve(process.cwd(), path.join(config.root.dest, b)); });

  var webpackConfig = webpackMutiConfig('development')
  var compiler = webpack(webpackConfig)

  var proxy = browserSyncConfig.proxy || null;
  if (typeof(proxy) === 'string') {
    browserSyncConfig.proxy = proxy = {
      target : proxy
    }
  }

  var server = proxy || browserSyncConfig.server;
  server.middleware = [
    require('webpack-dev-middleware')(compiler, {
      stats: 'errors-only',
      publicPath: pathToUrl('/', webpackConfig.output.publicPath)
    }),
    require('webpack-hot-middleware')(compiler),
    function (req, res, next) {
      res.setHeader('Access-Control-Allow-Origin', '*');
      next();
    }
  ];

  if (config.tasks.browserSync.rewrites) {
      var rewrites = [];
      for (var i = 0; i < config.tasks.browserSync.rewrites.length; i++) {
          var rewrite = config.tasks.browserSync.rewrites[i];
          rewrite.from = new RegExp(rewrite.from, 'i');
          rewrites.push(rewrite);
      }

      server.middleware.push(historyApiFallback({
          rewrites: rewrites
      }));
  }

  browserSync.init(browserSyncConfig)
};

gulp.task('browserSync', browserSyncTask)
module.exports = browserSyncTask
