var config = require('../lib/configReader.js')
if (!config.tasks.lint.js) return;

var gulp = require('gulp');
var eslint = require('gulp-eslint');
var path = require('path');

// source files are defined with their extensions in this case,
// because we dont want to try linting typescript files
var srcs = [];
var configFile = path.join(config.root.base, config.tasks.lint.js.config);

// add the srcs and exclude items to the srcs array
config.tasks.lint.js.extensions.forEach(function (ext) {
  config.tasks.lint.js.src.forEach(function (includeItem) {
    srcs.push(path.join(
      config.root.src, includeItem, '/**/*.' + ext
    ));
  });
  config.tasks.lint.js.exclude.forEach(function (excludeItem) {
    srcs.push('!' + path.join(
      config.root.src, excludeItem, '/**/*.' + ext
    ));
  });
});

function eslintTask() {
  // ESLint ignores files with "node_modules" paths.
  // So, it's best to have gulp ignore the directory as well.
  // Also, Be sure to return the stream from the task;
  // Otherwise, the task may end before the stream has finished.
  return gulp.src(srcs)
    .pipe(eslint({
      configFile: configFile
    }))
    .pipe(eslint.format())
    .pipe(eslint.failAfterError());
}

gulp.task('eslint', eslintTask);
module.exports = eslintTask
