var config          = require('../lib/configReader.js')
var gulp            = require('gulp')
var gulpSequence    = require('gulp-sequence')
var getEnabledTasks = require('../lib/getEnabledTasks')
var path            = require('path')
var del             = require('del')

gulp.task('copyTemplates', function() {
  var srcPath = path.join(config.root.dest, config.tasks.static.dest, 'templates', '**');
  var destPath = path.join(config.root.dest, config.tasks.static.dest);
  return gulp.src(srcPath).pipe(gulp.dest(destPath));
});

gulp.task('removeTemplatesFolder', ['copyTemplates'], function () {
  var srcPath = path.join(config.root.dest, config.tasks.static.dest, 'templates');
  del([srcPath], function() {})
});

var productionTask = function(cb) {
  global.production = true
  var tasks = getEnabledTasks('production')
  if (tasks.customProdTasks) {
    gulpSequence('clean', tasks.assetTasks, tasks.codeTasks, tasks.customProdTasks, config.tasks.production.rev ? 'rev' : false, 'size-report', 'static', cb)
  }
  else {
    gulpSequence('clean', tasks.assetTasks, tasks.codeTasks, config.tasks.production.rev ? 'rev' : false, 'size-report', 'static', cb)
  }
}

gulp.task('production', productionTask)
module.exports = productionTask
