var config = require('../lib/configReader.js');
var gulp   = require('gulp');
var path   = require('path');
var watch  = require('gulp-watch');

var watchTask = function() {
  var watchableTasks = ['fonts', 'iconFont', 'images', 'svgSprite','html', 'css', 'static'];

  watchableTasks.forEach(function(taskName) {
    var task = config.tasks[taskName];
    if(task) {
      var glob = [];
      glob.push(path.join(config.root.src, task.src, '**/*.{' + task.extensions.join(',') + '}'));

      // Ignoring temporary files pattern, as recommended here:
      // https://github.com/floatdrop/gulp-watch/issues/238
      // https://github.com/floatdrop/gulp-watch/issues/242
      if (task.excludeExtensions) {
          glob.push('!' + path.join(config.root.src, task.src, '**/*{' + task.excludeExtensions.join(',') + '}'));
      }

      if (task.watchSrc) {
        glob = [];
        task.watchSrc.forEach(function(watchPath) {
          glob.push(path.join(config.root.src, watchPath, '**/*.{' + task.extensions.join(',') + '}'));
            if (task.watchExcludeExtensions) {
                glob.push(path.join('!' + config.root.src, watchPath, '**/*{' + task.watchExcludeExtensions.join(',') + '}'));
            }
        });
      }
      watch(glob, function() {
        require('./' + taskName)()
      })
    }
  })
};

gulp.task('watch', ['browserSync'], watchTask);
module.exports = watchTask;
